'use strict';

exports.__esModule = true;
exports.ArraySort = exports.AddListTreeId = undefined;
exports.SetTableColumnsDate = SetTableColumnsDate;

var _cloneDeep2 = require('lodash/cloneDeep');

var _cloneDeep3 = _interopRequireDefault(_cloneDeep2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AddListTreeId = exports.AddListTreeId = function AddListTreeId(attr) {
  attr.map(function (v) {
    v.tree__id = Number(Math.random().toString().substr(3, 10) + Date.now()).toString(36);
  });
  return [].concat(attr);
};

var ArraySort = exports.ArraySort = function ArraySort(attr, name) {
  var _attr = [].concat(attr);
  _attr.sort(function (a, b) {
    return a[name] - b[name];
  });
  return _attr;
};

function SetTableColumnsDate(data, type, params) {
  var _cloneDeep = (0, _cloneDeep3.default)(params),
      columns = _cloneDeep.columns,
      _cloneDeep$original_c = _cloneDeep.original_columns,
      original_columns = _cloneDeep$original_c === undefined ? [] : _cloneDeep$original_c,
      _cloneDeep$fixedType = _cloneDeep.fixedType,
      fixedType = _cloneDeep$fixedType === undefined ? '' : _cloneDeep$fixedType,
      _cloneDeep$sortType = _cloneDeep.sortType,
      sortType = _cloneDeep$sortType === undefined ? '' : _cloneDeep$sortType;

  var current_columns = [].concat(columns);
  var return_columns = [];
  var leftList = [];
  var rightList = [];
  var list = [];
  var sort_columns = [];

  switch (type) {
    case 'reset':
      original_columns.map(function (v, k) {
        return v.sortSubscript = k;
      });
      return_columns = [].concat(original_columns);
      break;
    case 'select':
      current_columns.map(function (v) {
        return data.some(function (m) {
          return m === v.tree__id && !v.hideInSetting;
        }) ? v.disableQtable = false : '';
      });
      return_columns = [].concat(current_columns);
      break;
    case 'del':
      current_columns.map(function (v) {
        return data.some(function (m) {
          return m === v.tree__id && !v.hideInSetting;
        }) ? v.disableQtable = true : '';
      });
      return_columns = [].concat(current_columns);
      break;
    case 'fixed':
      current_columns.map(function (v) {
        if (v.tree__id === data[0]) {
          v.fixed = fixedType;
          v.disableQtable = false;
        }
        if (v.fixed === 'left') {
          leftList.push(v);
        } else if (v.fixed === 'right') {
          rightList.push(v);
        } else {
          delete v.fixed;
          list.push(v);
        }
      });
      return_columns = [].concat(leftList, ArraySort(list, 'sortSubscript'), rightList);
      break;
    case 'sort':
      current_columns.map(function (v) {
        if (v.fixed === 'left') {
          leftList.push(v);
        } else if (v.fixed === 'right') {
          rightList.push(v);
        } else {
          list.push(v);
        }
      });
      if (sortType === 'left') {
        leftList = [].concat(data);
      } else if (sortType === 'right') {
        rightList = [].concat(data);
      } else {
        list = [].concat(data);
      }
      sort_columns = [].concat(leftList, list, rightList);
      sort_columns.map(function (v, k) {
        return v.sortSubscript = k;
      });
      return_columns = [].concat(sort_columns);
      break;
  }
  return return_columns;
}