import Vue from 'vue'
import loadingVue from './loading.vue'
import { isChildOf } from 'src/utils/index'

const LoadingConstructor = Vue.extend(loadingVue)

const defaults = {
  visible: false,
  text: null,
  color: '#ccc',
  iconSize: 15,
  iconColor: '#BA2126',
  img: '',
  imgSize: 40,
  target: null,
  background: 'rgba(255, 255, 255, .8)'
}

const Loading = (options = {}) => {
  options.target = typeof options.target === 'string' ? document.querySelector(options.target) : document.body
  defaults.target = options.target;
  if (isChildOf(document.querySelector('.xpx-loading'), defaults.target)) return false
  options = Object.assign({}, defaults, options)
  const instance = new LoadingConstructor({
    el: document.createElement('div'),
    data: options
  })
  instance.close = function () {
    this.visible = false
    setTimeout(() => {
      if (options.target === document.body) options.target.classList.remove('xpx-loading-parent--body')
      else  options.target.classList.remove('xpx-loading-parent')
      options.target.removeChild(this.$el)
    }, 300)
  }
  if (options.target === document.body) {
    instance.$el.style.position = 'fixed'
    options.target.classList.add('xpx-loading-parent--body')
  } else {
    options.target.classList.add('xpx-loading-parent')

  }
  options.target.appendChild(instance.$el)
  Vue.nextTick(() => {
    instance.visible = true
  })
  return instance
}

export default Loading
