import cloneDeep from 'lodash/cloneDeep'

// 添加search__id唯一标识
export const AddListSearchId = (attr) => {
  attr.map(v => {
    v.search__id = Number(Math.random().toString().substr(3, 10) + Date.now()).toString(36)
  })
  return [...attr]
}

// 排序
export const ArraySort = (attr, name) => {
  const _attr = [...attr]
  _attr.sort((a, b) => {
    return a[name] - b[name]
  })
  return _attr
}

// 搜索项操作
export function SetSearchColumnsDate(
  data,
  type,
  params
) {
  const { columns, original_columns = [] } = cloneDeep(params)
  const current_columns = cloneDeep(columns)
  let return_columns = []
  switch (type) {
    case 'reset':
      original_columns.map((v, k) => (v.sortSubscript = k))
      return_columns = [...original_columns]
      break
    case 'select':
      current_columns.map((v) => data.some(m => m === v.search__id && !v.hideInSetting) ? (v.disableSearch = false) : '')
      return_columns = [...current_columns]
      break
    case 'del':
      current_columns.map((v) => data.some(m => m === v.search__id && !v.hideInSetting) ? (v.disableSearch = true) : '')
      return_columns = [...current_columns]
      break
    case 'sort':
      data.map((v, k) => (v.sortSubscript = k))
      return_columns = [...data]
      break
  }
  return return_columns
}
