import XTable from './components/XTable/index.js'
import XSearch from './components/XSearch/index.js'
import XProSku from './components/XProSku/index.js'
import XUpload from './components/XUpload/index.js'
import XVideo from './components/XVideo/index.js'
import XCropper from './components/XCropper/index.js'
import XLoading from './components/XLoading/index.js'
import XNum from './components/XNum/index.js'
import XSkeleton from './components/XSkeleton/index.js'
import XProInput from './components/XProInput/index.js'
import XProGoodsSku from './components/XProGoodsSku/index.js'

const components = [
  XTable,
  XSearch,
  XProSku,
  XUpload,
  XVideo,
  XCropper,
  XLoading,
  XNum,
  XSkeleton,
  XProInput,
  XProGoodsSku
]

const install = function(Vue) {
  components.forEach(component => {
    Vue.component(component.name, component)
  })
  XLoading.install(Vue)
}

if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue)
}

export default {
  install,
    XTable,
  XSearch,
  XProSku,
  XUpload,
  XVideo,
  XCropper,
  XLoading,
  XNum,
  XSkeleton,
  XProInput,
  XProGoodsSku
}
