import Vue from 'vue'

import { XpxTable } from './xtable'
import { XpxSearch } from './xsearch'
import { XpxProSku } from './xproSku'
import { XpxUpload } from './xupload'
import { XpxVideo } from './xvideo'
import { XpxCropper } from './xcropper'
import { XpxLoading } from './xloading'
import { XpxNum } from './xnum'
import { XpxSkeleton } from './xskeleton'
import { XpxProInput } from './xproInput'
import { XpxProGoodsSku } from './xproGoodsSku'

export interface InstallationOptions {
  locale: any,
  i18n: any,
  size: string
}

/**
 * Install all xpx-ui components into Vue.
 * Please do not invoke this method directly.
 * Call `Vue.use(XUI)` to install.
 */
export function install (vue: typeof Vue, options: InstallationOptions): void


/** Popconfirm Component */
export class XTable extends XpxTable {}
export class XSearch extends XpxSearch {}
export class XProSku extends XpxProSku {}
export class XUpload extends XpxUpload {}
export class XVideo extends XpxVideo {}
export class XCropper extends XpxCropper {}
export class XLoading extends XpxLoading {}
export class XNum extends XpxNum {}
export class XSkeleton extends XpxSkeleton {}
export class XProInput extends XpxProInput {}
export class XProGoodsSku extends XpxProGoodsSku {}
